# Remote deploy
#######################
# variables:
#   IMAGE_DOCKER: "docker:25.0.3"
#   IMAGE_DIND: "docker:25.0.3-dind"
#   DOCKER_DRIVER: overlay2
#   DOCKER_TLS_CERTDIR: ""
#   # DOCKER_HOST: tcp://docker:2375
#   TARGETHOST: "192.168.17.25"
#   TARGETUSER: "alex"
#   HOST_PORT: "80"

#########################
.docker-compose-deploy-to:
  image: ${IMAGE_DOCKER}
  services:
    - ${IMAGE_DIND}
  script:
    - "which ssh-agent || ( apt-get update -y && apt-get install openssh-client git -y )"
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - ssh-keyscan ${TARGETHOST} >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts

    - unset DOCKER_HOST
    - docker context create remote --docker "host=ssh://${TARGETUSER}@${TARGETHOST}"
    - docker context use remote
    - docker-compose --context remote down
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - docker-compose --context remote up -d --force-recreate
    - echo " Connect to ===> http://${TARGETHOST}:${HOST_PORT}"
  # rules:
  #   - if: $CI_COMMIT_BRANCH == 'dev'
  tags:
    - docker
